
var g_circle_factory = null;

function Erase()
{
	if ( !g_circle_factory )
		return;

	var cutters = g_circle_factory.getCreatedObjects();

	var using_selected = true;
	var base_objects = moi.geometryDatabase.getSelectedObjects();
	if ( base_objects.length == 0 )
	{
		using_selected = false;
		base_objects = moi.geometryDatabase.getObjects();
	}

	var bool_factory = moi.command.createFactory( 'booleandifference' );
	bool_factory.setInput( 0, base_objects );
	bool_factory.setInput( 1, cutters );
	bool_factory.update();

	if ( using_selected )
		bool_factory.getCreatedObjects().setProperty( 'selected', true );

	bool_factory.commit();
}

function Update( pointpicker )
{
	if ( !g_circle_factory )
		g_circle_factory = moi.command.createFactory( 'circle' );

	var frame = pointpicker.ptFrame;
	var radius = moi.ui.commandUI.radius.value;

	g_circle_factory.setInput( 0, true );   // True = distance input is radius, False = distance input is diameter.
	g_circle_factory.setInput( 1, frame );  // Center point + x/y axes
	g_circle_factory.setInput( 3, radius ); 

	g_circle_factory.update();

	moi.ui.clearPickedPoints();
}

function DoEraser()
{
	var pointpicker = moi.ui.createPointPicker();
	pointpicker.bindFunc( Update );

	while ( 1 )
	{
		if ( !pointpicker.waitForEvent() )
			return false;

		if ( pointpicker.event == 'done' )
			break;

		if ( pointpicker.event == 'radius' )
			Update( pointpicker );
			
		if ( pointpicker.event == 'finished' )
			Erase( pointpicker.pt );
	}

}

DoEraser();
